#!/usr/bin/python
"""
This file is part of jam-control.

jam-control is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

fedora-audio-control is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with jam-control.  If not, see <http://www.gnu.org/licenses/>.
"""

import os, dbus
def which(program):
    fpath, fname = os.path.split(program)
    def is_exe(fpath):
        return os.path.isfile(fpath) and os.access(fpath, os.X_OK)

    
    if fpath:
        if is_exe(program):
            return program
    else:
        for path in os.environ["PATH"].split(os.pathsep):
            exe_file = os.path.join(path, program)
            if is_exe(exe_file):
                return exe_file

    return None


def hasPulse():
    ret = which("pacmd")
    if ret == None:
        return False
    else:
        return True
  
def hasJackDbus():
    bus = dbus.SessionBus()
    try:
        jackdbus = bus.get_object("org.jackaudio.service", "/org/jackaudio/controller") 
        return True
    except dbus.exceptions.DBusException:
        return False                       

def hasJack():
    #check if jack is installed
    ret = which("jackd")
    if ret == None:
        return False
    else:
        return True
      
    return True
#        except dbus.exceptions.DBusException:
#            print "exception"
#            return False
      #print jackDbus        
